FFPLAY(1)

NAME
ffplay - FFplay media player

SYNOPSIS
ffplay [options] [input_file]

DESCRIPTION
FFplay is a very simple and portable media player using the FFmpeg libraries and the SDL library. It is mostly used as a testbed for the various FFmpeg APIs.

OPTIONS
All the numerical options, if not specified otherwise, accept a string representing a number as input, which may be followed by one of the SI unit prefixes, for example: 'K', 'M', or 'G'.

If 'i' is appended to the SI unit prefix, the complete prefix will be interpreted as a unit prefix for binary multiplies, which are based on powers of 1024 instead of powers of 1000. Appending 'B' to the SI unit prefix multiplies the value by 8. This allows using, for example: 'KB', 'MiB', 'G' and 'B' as number suffixes.

Options which do not take arguments are boolean options, and set the corresponding value to true. They can be set to false by prefixing the option name with "no". For example using "-nofoo" will set the boolean option with name "foo" to false.

  Stream specifiers
Some options are applied per-stream, e.g. bitrate or codec. Stream specifiers are used to precisely specify which stream(s) a given option belongs to.

A stream specifier is a string generally appended to the option name and separated from it by a colon. E.g. "-codec:a:1 ac3" contains the "a:1" stream specifier, which matches the second audio stream. Therefore, it would select the ac3 codec for the second audio stream.

A stream specifier can match several streams, so that the option is applied to all of them. E.g. the stream specifier in "-b:a 128k" matches all audio streams.

An empty stream specifier matches all streams. For example, "-codec copy" or "-codec: copy" would copy all the streams without reencoding.

Possible forms of stream specifiers are:

stream_index
    Matches the stream with this index. E.g. "-threads:1 4" would set the thread count for the second stream to 4.

stream_type[:stream_index]
    stream_type is one of following: 'v' for video, 'a' for audio, 's' for subtitle, 'd' for data, and 't' for attachments. If stream_index is given, then it matches stream number stream_index of this type. Otherwise, it matches all streams of this type.

p:program_id[:stream_index]
    If stream_index is given, then it matches the stream with number stream_index in the program with the id program_id. Otherwise, it matches all streams in the program.

#stream_id
    Matches the stream by a format-specific ID.

  Generic options
These options are shared amongst the ff* tools.

-L  Show license.

-h, -?, -help, --help [arg]
    Show help. An optional parameter may be specified to print help about a specific item. If no argument is specified, only basic (non advanced) tool options are shown.

    Possible values of arg are:

    long
        Print advanced tool options in addition to the basic tool options.

    full
        Print complete list of options, including shared and private options for encoders, decoders, demuxers, muxers, filters, etc.

    decoder=decoder_name
        Print detailed information about the decoder named decoder_name. Use the -decoders option to get a list of all decoders.

    encoder=encoder_name
        Print detailed information about the encoder named encoder_name. Use the -encoders option to get a list of all encoders.

    demuxer=demuxer_name
        Print detailed information about the demuxer named demuxer_name. Use the -formats option to get a list of all demuxers and muxers.

    muxer=muxer_name
        Print detailed information about the muxer named muxer_name. Use the -formats option to get a list of all muxers and demuxers.

    filter=filter_name
        Print detailed information about the filter name filter_name. Use the -filters option to get a list of all filters.

-version
    Show version.

-formats
    Show available formats.

-codecs
    Show all codecs known to libavcodec.

    Note that the term 'codec' is used throughout this documentation as a shortcut for what is more correctly called a media bitstream format.

-decoders
    Show available decoders.

-encoders
    Show all available encoders.

-bsfs
    Show available bitstream filters.

-protocols
    Show available protocols.

-filters
    Show available libavfilter filters.

-pix_fmts
    Show available pixel formats.

-sample_fmts
    Show available sample formats.

-layouts
    Show channel names and standard channel layouts.

-colors
    Show recognized color names.

-loglevel [repeat+]loglevel | -v [repeat+]loglevel
    Set the logging level used by the library. Adding "repeat+" indicates that repeated log output should not be compressed to the first line and the "Last message repeated n times" line will be omitted. "repeat" can also be used alone. If "repeat" is used alone, and with no prior loglevel set, the default loglevel will be used. If multiple loglevel parameters are given, using 'repeat' will not change the loglevel. loglevel is a number or a string containing one of the following values:

    quiet
        Show nothing at all; be silent.

    panic
        Only show fatal errors which could lead the process to crash, such as and assert failure. This is not currently used for anything.

    fatal
        Only show fatal errors. These are errors after which the process absolutely cannot continue after.

    error
        Show all errors, including ones which can be recovered from.

    warning
        Show all warnings and errors. Any message related to possibly incorrect or unexpected events will be shown.

    info
        Show informative messages during processing. This is in addition to warnings and errors. This is the default value.

    verbose
        Same as "info", except more verbose.

    debug
        Show everything, including debugging information.

    By default the program logs to stderr, if coloring is supported by the terminal, colors are used to mark errors and warnings. Log coloring can be disabled setting the environment variable AV_LOG_FORCE_NOCOLOR or NO_COLOR, or can be forced setting the environment variable AV_LOG_FORCE_COLOR. The use of the environment variable NO_COLOR is deprecated and will be dropped in a following FFmpeg version.

-report
    Dump full command line and console output to a file named "program-YYYYMMDD-HHMMSS.log" in the current directory. This file can be useful for bug reports. It also implies "-loglevel verbose".

    Setting the environment variable "FFREPORT" to any value has the same effect. If the value is a ':'-separated key=value sequence, these options will affect the report; options values must be escaped if they contain special characters or the options delimiter ':' (see the ``Quoting and escaping'' section in the ffmpeg-utils manual). The following option is recognized:

    file
        set the file name to use for the report; %p is expanded to the name of the program, %t is expanded to a timestamp, "%%" is expanded to a plain "%"

    Errors in parsing the environment variable are not fatal, and will not appear in the report.

-hide_banner
    Suppress printing banner.

    All FFmpeg tools will normally show a copyright notice, build options and library versions. This option can be used to suppress printing this information.

-cpuflags flags (global)
    Allows setting and clearing cpu flags. This option is intended for testing. Do not use it unless you know what you're doing.

            ffmpeg -cpuflags -sse+mmx ...
            ffmpeg -cpuflags mmx ...
            ffmpeg -cpuflags 0 ...

    Possible flags for this option are:

    x86
        mmx
        mmxext
        sse
        sse2
        sse2slow
        sse3
        sse3slow
        ssse3
        atom
        sse4.1
        sse4.2
        avx
        xop
        fma4
        3dnow
        3dnowext
        cmov
    ARM
        armv5te
        armv6
        armv6t2
        vfp
        vfpv3
        neon
    PowerPC
        altivec
    Specific Processors
        pentium2
        pentium3
        pentium4
        k6
        k62
        athlon
        athlonxp
        k8
-opencl_bench
    Benchmark all available OpenCL devices and show the results. This option is only available when FFmpeg has been compiled with "--enable-opencl".

-opencl_options options (global)
    Set OpenCL environment options. This option is only available when FFmpeg has been compiled with "--enable-opencl".

    options must be a list of key=value option pairs separated by ':'. See the ``OpenCL Options'' section in the ffmpeg-utils manual for the list of supported options.

  AVOptions
These options are provided directly by the libavformat, libavdevice and libavcodec libraries. To see the list of available AVOptions, use the -help option. They are separated into two categories:

generic
    These options can be set for any container, codec or device. Generic options are listed under AVFormatContext options for containers/devices and under AVCodecContext options for codecs.

private
    These options are specific to the given container, device or codec. Private options are listed under their corresponding containers/devices/codecs.

For example to write an ID3v2.3 header instead of a default ID3v2.4 to an MP3 file, use the id3v2_version private option of the MP3 muxer:

        ffmpeg -i input.flac -id3v2_version 3 out.mp3

All codec AVOptions are per-stream, and thus a stream specifier should be attached to them.

Note: the -nooption syntax cannot be used for boolean AVOptions, use -option 0/-option 1.

Note: the old undocumented way of specifying per-stream AVOptions by prepending v/a/s to the options name is now obsolete and will be removed soon.

  Main options

-x width
    Force displayed width.

-y height
    Force displayed height.

-s size
    Set frame size (WxH or abbreviation), needed for videos which do not contain a header with the frame size like raw YUV. This option has been deprecated in favor of private options, try -video_size.

-an Disable audio.

-vn Disable video.

-ss pos
    Seek to a given position in seconds.

-t duration
    play <duration> seconds of audio/video

-bytes
    Seek by bytes.

-nodisp
    Disable graphical display.

-f fmt
    Force format.

-window_title title
    Set window title (default is the input filename).

-loop number
    Loops movie playback <number> times. 0 means forever.

-showmode mode
    Set the show mode to use. Available values for mode are:

    0, video
        show video

    1, waves
        show audio waves

    2, rdft
        show audio frequency band using RDFT ((Inverse) Real Discrete Fourier Transform)

    Default value is "video", if video is not present or cannot be played "rdft" is automatically selected.

    You can interactively cycle through the available show modes by pressing the key w.

-vf filtergraph
    Create the filtergraph specified by filtergraph and use it to filter the video stream.

    filtergraph is a description of the filtergraph to apply to the stream, and must have a single video input and a single video output. In the filtergraph, the input is associated to the label "in", and the output to the label "out". See the ffmpeg-filters manual for more information about the filtergraph syntax.

-af filtergraph
    filtergraph is a description of the filtergraph to apply to the input audio. Use the option "-filters" to show all the available filters (including sources and sinks).

-i input_file
    Read input_file.

  Advanced options

-pix_fmt format
    Set pixel format. This option has been deprecated in favor of private options, try -pixel_format.

-stats
    Print several playback statistics, in particular show the stream duration, the codec parameters, the current position in the stream and the audio/video synchronisation drift. It is on by default, to explicitly disable it you need to specify "-nostats".

-bug
    Work around bugs.

-fast
    Non-spec-compliant optimizations.

-genpts
    Generate pts.

-rtp_tcp
    Force RTP/TCP protocol usage instead of RTP/UDP. It is only meaningful if you are streaming with the RTSP protocol.

-sync type
    Set the master clock to audio ("type=audio"), video ("type=video") or external ("type=ext"). Default is audio. The master clock is used to control audio-video synchronization. Most media players use audio as master clock, but in some cases (streaming or high quality broadcast) it is necessary to change that. This option is mainly used for debugging purposes.

-threads count
    Set the thread count.

-ast audio_stream_number
    Select the desired audio stream number, counting from 0. The number refers to the list of all the input audio streams. If it is greater than the number of audio streams minus one, then the last one is selected, if it is negative the audio playback is disabled.

-vst video_stream_number
    Select the desired video stream number, counting from 0. The number refers to the list of all the input video streams. If it is greater than the number of video streams minus one, then the last one is selected, if it is negative the video playback is disabled.

-sst subtitle_stream_number
    Select the desired subtitle stream number, counting from 0. The number refers to the list of all the input subtitle streams. If it is greater than the number of subtitle streams minus one, then the last one is selected, if it is negative the subtitle rendering is disabled.

-autoexit
    Exit when video is done playing.

-exitonkeydown
    Exit if any key is pressed.

-exitonmousedown
    Exit if any mouse button is pressed.

-codec:media_specifier codec_name
    Force a specific decoder implementation for the stream identified by media_specifier, which can assume the values "a" (audio), "v" (video), and "s" subtitle.

-acodec codec_name
    Force a specific audio decoder.

-vcodec codec_name
    Force a specific video decoder.

-scodec codec_name
    Force a specific subtitle decoder.

  While playing

q, ESC
    Quit.

f   Toggle full screen.

p, SPC
    Pause.

a   Cycle audio channel in the curret program.

v   Cycle video channel.

t   Cycle subtitle channel in the current program.

c   Cycle program.

w   Show audio waves.

s   Step to the next frame.

    Pause if the stream is not already paused, step to the next video frame, and pause.

left/right
    Seek backward/forward 10 seconds.

down/up
    Seek backward/forward 1 minute.

page down/page up
    Seek to the previous/next chapter. or if there are no chapters Seek backward/forward 10 minutes.

mouse click
    Seek to percentage in file corresponding to fraction of width.

SEE ALSO
ffplay-all(1), ffmpeg(1), ffprobe(1), ffserver(1), ffmpeg-utils(1), ffmpeg-scaler(1), ffmpeg-resampler(1), ffmpeg-codecs(1), ffmpeg-bitstream-filters(1), ffmpeg-formats(1), ffmpeg-devices(1), ffmpeg-protocols(1), ffmpeg-filters(1)

AUTHORS
The FFmpeg developers.

For details about the authorship, see the Git history of the project (git://source.ffmpeg.org/ffmpeg), e.g. by typing the command git log in the FFmpeg source directory, or browsing the online repository at <http://source.ffmpeg.org>.

Maintainers for the specific components are listed in the file MAINTAINERS in the source code tree.